#include "descriptor/descriptor.h"

main(){	       
	ITEM brown,gray;
	ITEM piattaforma,torre1,torre2,torre3,torre4;
	ITEM facciata1,facciata2,facciata3,facciata4;
	ITEM colonna, cupolina, portale, finestra, cup, spigolo_back;
	ITEM spigolo1,spigolo2,spigolo3,spigolo4;
	ITEM cappella1,cappella2,cappella3,cappella4,piano,cupola,guglia;
	ITEM scene;
	
	set_background(0.676,0.861,0.953,TRUE);
	set_ambient_light(1,1,1,4.0);
	create_point_light(1.6,-0.4,16,1,1,1,2,20, "light1");
	create_point_light(-8.3,16.7,4.3,1,1,1,2,25, "light2");
	create_point_light(14.8,-0.2,5.0,1,1,1,2,25, "light3");
	
	/*** ATTRIBUTE brown ***/
	brown = create_attribute("brown");
	set_color(brown,0.43,0.2,0.0,0.2,0.8);
	set_reflectivity(brown,0.17,15);

	/*** ATTRIBUTE gray ***/
	gray = create_attribute("gray");
	set_color(gray,1.0,0.866,0.855,0.1,0.8);
	  

	/*** Piattaforma ***/
	piattaforma = read_obj("piattaforma.obj", "piattaforma");
	set_scale(piattaforma, 0.5, 0.5, 1);
	set_projection_texture(piattaforma, gray, "texture/murato.hr", TRUE, 2, 0.6, 0.8);
	set_scale(piattaforma, 1.0/0.5, 1.0/0.5, 1);


	/*** Torri ***/
	torre1 = read_obj("torre.obj", "torre1");
	set_translate(torre1,0.3,0.3,0);
	
	torre2 = create_copy(torre1, "torre2");
	set_translate(torre2,-2.6,0,0);

	torre3 = create_copy(torre1, "torre3");
	set_translate(torre3,-2.6,-2.6,0);

	torre4 = create_copy(torre1, "torre4");
	set_translate(torre4,0,-2.6,0);

	colonna = read_nurbs("pilastro.db");
	set_translate(colonna, -1.0, -1.0, -0.1);
	set_projection_texture(colonna, gray, "texture/murato.hr", TRUE, 2, 0.6, 0.8);
	set_translate(colonna, 1.0, 1.0, 0.1);
	set_translate(colonna,0.3,0.3,0);

	cupolina = read_nurbs("cupolapiccolaS.db");
	set_translate(cupolina, -1.0, -1.0, -0.5);
	set_projection_texture(cupolina, gray, "texture/murato.hr", TRUE, 2, 0.6, 0.8);
	set_translate(cupolina, 1.0, 1.0, 0.5);
	set_translate(cupolina,0.3,0.3,0);
	
	set_attribute(torre1,gray);
	set_attribute(torre2,gray);
	set_attribute(torre3,gray);
	set_attribute(torre4,gray);

	/*** Facciate ***/
	facciata1 = read_obj("facciata.obj", "facciata1");

	facciata2 = create_copy(facciata1, "facciata2");
	set_z_rotate(facciata2,90,1);
	
	facciata3 = create_copy(facciata1, "facciata3");
        set_z_rotate(facciata3,180,1);

	facciata4 = create_copy(facciata1, "facciata4");
        set_z_rotate(facciata4,-90,1);

		/*  Ingresso */
	portale = read_nurbs("facciata_back.db");
	set_translate(portale, 0.0, -0.7, 0.2);
	set_scale(portale, 1.0/0.15, 1.0, 1.0/0.3);
	set_projection_texture(portale, gray, "texture/entrata.hr", TRUE, 2, 0.6, 0.8);
	set_scale(portale, 0.15, 1.0, 0.3);
	set_translate(portale, 0.0, 0.7, -0.2);

		/* Finestre*/
	finestra = read_nurbs("finestra_back.db");
	set_translate(finestra, -0.375, -0.7, -0.15);
	set_scale(finestra, 1.0/0.08, 1.0, 1.0/0.1);
	set_projection_texture(finestra, gray, "texture/finestra.hr", TRUE, 2, 0.6, 0.8);
	set_scale(finestra, 0.08, 1.0, 0.1);
	set_translate(finestra, 0.375, 0.7, 0.15);		
	
	set_attribute(facciata1,gray);
	set_attribute(facciata2,gray);
	set_attribute(facciata3,gray);
	set_attribute(facciata4,gray);

	/*** Piano Superiore ***/
	piano = read_obj("pianosuperiore.obj", "pianoSuperiore");
	set_attribute(piano,gray);

	/*** Cupola***/
	cupola = read_nurbs("cupolaS.db");
	set_translate(cupola, -0.45, -0.45, -0.8);
	set_projection_texture(cupola, gray, "texture/murato.hr", TRUE, 2, 0.6, 0.8);
	set_translate(cupola, 0.45, 0.45, 0.8);

	/*** Guglia ***/
	guglia = read_nurbs("pennonecentrale2.db");
	set_attribute(guglia,brown);

	/*** Cappelle ***/
	cappella1 = read_obj("cappella.obj", "cappela1");
	
	cappella2 = create_copy(cappella1, "cappella2");
	set_translate(cappella2,-0.9,0,0);

	cappella3 = create_copy(cappella1, "cappella3");
	set_translate(cappella3,-0.9,-0.9,0);
	
	cappella4 = create_copy(cappella1, "cappella4");
	set_translate(cappella4,0,-0.9,0);

	 
	cup = read_nurbs("cupola.db");
	set_translate(cup,  -0.45, -0.45, -0.8);
	set_projection_texture(cup, gray, "texture/murato.hr", TRUE, 2, 0.6, 0.8);	
	set_translate(cup, 0.45, 0.45, 0.8);

	set_attribute(cappella1,gray);
	set_attribute(cappella2,gray);
	set_attribute(cappella3,gray);
	set_attribute(cappella4,gray);

	/*** Spigoli ***/
	spigolo1 = read_obj("spigolo.obj", "spigolo1");

	spigolo2 = create_copy(spigolo1, "spigolo2");
	set_z_rotate(spigolo2,90,1);

	spigolo4 = create_copy(spigolo1, "spigolo4");
        set_z_rotate(spigolo4,-90,1);
	
	spigolo3 = create_copy(spigolo4, "spigolo3");
        set_z_rotate(spigolo3,-90,1);

	spigolo_back = read_nurbs("spigolo_back.db");
	set_translate(spigolo_back, 0.7, -0.7, -0.35);
	set_z_rotate(spigolo_back,-45,1);
	set_scale(spigolo_back, 1.0/0.08, 1.0, 1.0/0.1);
	set_projection_texture(spigolo_back, gray, "texture/finestra.hr", TRUE, 2, 0.6, 0.8);
	set_scale(spigolo_back, 0.08, 1.0, 0.1);
	set_z_rotate(spigolo_back,45,1);
	set_translate(spigolo_back, -0.7, 0.7, 0.35);

	set_attribute(spigolo1,gray);
	set_attribute(spigolo2,gray);
	set_attribute(spigolo3,gray);
	set_attribute(spigolo4,gray);
	
	/* hierarchy initialization and construction */
	scene = create_list(piattaforma, "scene");
	scene = insert_in_list(scene, create_copy(colonna, "colonna1"));
	set_translate(colonna,-2.6,0,0);
	scene = insert_in_list(scene, create_copy(colonna, "colonna2"));
	set_translate(colonna,0,-2.6,0);
	scene = insert_in_list(scene, create_copy(colonna, "colonna3"));
	set_translate(colonna,2.6,0,0);
	scene = insert_in_list(scene, create_copy(colonna, "colonna4"));
	scene = insert_in_list(scene, create_copy(cupolina, "cupolina1"));
	set_translate(cupolina,-2.6,0,0);
	scene = insert_in_list(scene, create_copy(cupolina, "cupolina2"));
	set_translate(cupolina,0,-2.6,0);
	scene = insert_in_list(scene, create_copy(cupolina, "cupolina3"));
	set_translate(cupolina,2.6,0,0);
	scene = insert_in_list(scene, create_copy(cupolina, "cupolina4"));
		/* Ingresso*/
	
	scene = insert_in_list(scene, create_copy(portale, "entrata1"));
	set_z_rotate(portale,90,1);
	scene = insert_in_list(scene, create_copy(portale, "entrata2"));
	set_z_rotate(portale,90,1);
	scene = insert_in_list(scene, create_copy(portale, "entrata3"));
	set_z_rotate(portale,90,1);
	scene = insert_in_list(scene, create_copy(portale, "entrata4"));
	
		/* finestre */
	scene = insert_in_list(scene, create_copy(finestra, "back_sin_su1"));
	set_z_rotate(finestra,90,1);
	scene = insert_in_list(scene, create_copy(finestra, "back_sin_su2"));
	set_z_rotate(finestra,90,1);
	scene = insert_in_list(scene, create_copy(finestra, "back_sin_su3"));
	set_z_rotate(finestra,90,1);
	scene = insert_in_list(scene, create_copy(finestra, "back_sin_su4"));
	set_z_rotate(finestra,90,1);
	
	set_translate(finestra,0.0,0.0,-0.35);
	scene = insert_in_list(scene, create_copy(finestra, "back_sin_giu1"));
	set_z_rotate(finestra,90,1);
	scene = insert_in_list(scene, create_copy(finestra, "back_sin_giu2"));
	set_z_rotate(finestra,90,1);
	scene = insert_in_list(scene, create_copy(finestra, "back_sin_giu3"));
	set_z_rotate(finestra,90,1);
	scene = insert_in_list(scene, create_copy(finestra, "back_sin_giu4"));
	set_z_rotate(finestra,90,1);						
	
	set_translate(finestra,-0.75,0.0,0.0);
	scene = insert_in_list(scene, create_copy(finestra, "back_des_giu1"));
	set_z_rotate(finestra,90,1);
	scene = insert_in_list(scene, create_copy(finestra, "back_des_giu2"));
	set_z_rotate(finestra,90,1);                            
	scene = insert_in_list(scene, create_copy(finestra, "back_des_giu3"));
	set_z_rotate(finestra,90,1);                                            
	scene = insert_in_list(scene, create_copy(finestra, "back_des_giu4"));
	set_z_rotate(finestra,90,1);

	set_translate(finestra,0.0,0.0,0.35);
	scene = insert_in_list(scene, create_copy(finestra, "back_des_su1"));
	set_z_rotate(finestra,90,1);
	scene = insert_in_list(scene, create_copy(finestra, "back_des_su2"));
	set_z_rotate(finestra,90,1);
	scene = insert_in_list(scene, create_copy(finestra, "back_des_su3"));
	set_z_rotate(finestra,90,1);
	scene = insert_in_list(scene, create_copy(finestra, "back_des_su4"));
	
		/* cup */
	scene = insert_in_list(scene, create_copy(cup, "cup1"));
	set_translate(cup,-0.9,0,0);
	scene = insert_in_list(scene, create_copy(cup, "cup2"));
	set_translate(cup,0,-0.9,0);
	scene = insert_in_list(scene, create_copy(cup, "cup3"));
	set_translate(cup,0.9,0,0);
	scene = insert_in_list(scene, create_copy(cup, "cup4"));
	scene = insert_in_list(scene,torre1);
	scene = insert_in_list(scene,torre2);
	scene = insert_in_list(scene,torre3);
	scene = insert_in_list(scene,torre4);
	scene = insert_in_list(scene,facciata1);
	scene = insert_in_list(scene,facciata2);
	scene = insert_in_list(scene,facciata3);
	scene = insert_in_list(scene,facciata4);
	scene = insert_in_list(scene,piano);
	scene = insert_in_list(scene,guglia);
	scene = insert_in_list(scene,cupola);
	scene = insert_in_list(scene,cappella1);
	scene = insert_in_list(scene,cappella2);
	scene = insert_in_list(scene,cappella3);
	scene = insert_in_list(scene,cappella4);
		/* Spigoli */
	scene = insert_in_list(scene, create_copy(spigolo_back, "spigolo_back_su1"));
	set_z_rotate(spigolo_back,90,1);
	scene = insert_in_list(scene, create_copy(spigolo_back, "spigolo_back_su2"));
	set_z_rotate(spigolo_back,90,1);
	scene = insert_in_list(scene, create_copy(spigolo_back, "spigolo_back_su3"));
	set_z_rotate(spigolo_back,90,1);
	scene = insert_in_list(scene, create_copy(spigolo_back, "spigolo_back_su4"));
	set_z_rotate(spigolo_back,90,1);
	
	set_translate(spigolo_back,0.0,0.0,-0.35);
	scene = insert_in_list(scene, create_copy(spigolo_back, "spigolo_back_giu1"));
	set_z_rotate(spigolo_back,90,1);
	scene = insert_in_list(scene, create_copy(spigolo_back, "spigolo_back_giu2"));
	set_z_rotate(spigolo_back,90,1);
	scene = insert_in_list(scene, create_copy(spigolo_back, "spigolo_back_giu3"));
	set_z_rotate(spigolo_back,90,1);
	scene = insert_in_list(scene, create_copy(spigolo_back, "spigolo_back_giu4"));
							
	scene = insert_in_list(scene,spigolo1);
	scene = insert_in_list(scene,spigolo2);
	scene = insert_in_list(scene,spigolo3);
	scene = insert_in_list(scene,spigolo4);

	save_scene("TajMahal.md","scene_TajMahal",scene);
	return(0);
}
												
